'
' Small demo of a way to show MSInfo32 sysinfo.
' Could be useful in an About.. -dialog, for example.
' Compiled with PB/WIN 7.02, tested under Win98 only.
' Public Domain by Borje Hagsten, March 2003
'--------------------------------------------------------------------
#COMPILE EXE
#INCLUDE "WIN32API.INC"
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc() AS LONG
DECLARE FUNCTION RegGetKey(BYVAL dwMainKey AS DWORD, _
                           BYVAL sSubKey AS STRING, _
                           BYVAL sItem AS STRING) AS STRING
DECLARE SUB ShowSysInfo
 
'
' Main entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD, lRes AS LONG
 
  DIALOG NEW 0, "MS SysInfo demo",,, 240, 120, %WS_CAPTION OR %WS_SYSMENU, 0 TO hDlg
 
  CONTROL ADD BUTTON, hDlg, %IDOK, "&SysInfo",  132, 102, 50, 14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Quit", 186, 102, 50, 14
 
  DIALOG SHOW MODAL hDlg CALL DlgProc
 
END FUNCTION
 
'
' Main callback
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgProc() AS LONG
  SELECT CASE CBMSG
      CASE %WM_INITDIALOG  ' <- can initiate variables and control, etc. here
 
     CASE %WM_COMMAND      ' <- a control is calling
        SELECT CASE CBCTL  ' <- look at control's id
           CASE %IDOK
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 ShowSysInfo
              END IF
 
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN 'end prog
                 DIALOG END CBHNDL
              END IF
 
        END SELECT
  END SELECT
END FUNCTION
 
'
' Get given registry subkey's value
'--------------------------------------------------------------------
FUNCTION RegGetKey(BYVAL dwMainKey AS DWORD, _
                   BYVAL sSubKey AS STRING, _
                   BYVAL sItem AS STRING) AS STRING
 
  LOCAL hKey AS DWORD, zBuff AS ASCIIZ * 1024
 
  IF RegOpenKeyEx(dwMainKey, BYVAL STRPTR(sSubKey), 0, _
                  %KEY_QUERY_VALUE, hKey) = %ERROR_SUCCESS THEN
     IF hKey THEN
        RegQueryValueEx hKey, BYVAL STRPTR(sItem), 0, 0, zBuff, SIZEOF(zBuff)
        RegCloseKey hKey
        FUNCTION = EXTRACT$(zBuff, CHR$(0))
     END IF
  END IF
 
END FUNCTION
 
'
' Show MSInfo32 - first look in Registry for path, the SHELL..
'--------------------------------------------------------------------
SUB ShowSysInfo
  LOCAL lRes AS LONG, sPath AS STRING

  sPath = RegGetKey(%HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Shared Tools\MSInfo", "Path")
 
  IF LEN(sPath) THEN
     lRes = SHELL(sPath) ' think asynchronous run is best here, so use SHELL as function
     EXIT SUB            ' exit sub on success..
  END IF
 
  'if we reach here, MSInfo32 path could not be found, so flash a message, or whatever..
  MSGBOX "Could not find MSInfo32.exe"
END SUB
